# coding: utf-8
# Copyright 2023 OpenSPG Authors
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.

"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.common.rest.configuration import Configuration


class PredictingConfig(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"target": "str", "predicting_config": "BasePredictingConfig"}

    attribute_map = {"target": "target", "predicting_config": "predictingConfig"}

    def __init__(
        self, target=None, predicting_config=None, local_vars_configuration=None
    ):  # noqa: E501
        """PredictingConfig - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._target = None
        self._predicting_config = None
        self.discriminator = None

        if target is not None:
            self.target = target
        if predicting_config is not None:
            self.predicting_config = predicting_config

    @property
    def target(self):
        """Gets the target of this PredictingConfig.  # noqa: E501


        :return: The target of this PredictingConfig.  # noqa: E501
        :rtype: str
        """
        return self._target

    @target.setter
    def target(self, target):
        """Sets the target of this PredictingConfig.


        :param target: The target of this PredictingConfig.  # noqa: E501
        :type: str
        """

        self._target = target

    @property
    def predicting_config(self):
        """Gets the predicting_config of this PredictingConfig.  # noqa: E501


        :return: The predicting_config of this PredictingConfig.  # noqa: E501
        :rtype: BasePredictingConfig
        """
        return self._predicting_config

    @predicting_config.setter
    def predicting_config(self, predicting_config):
        """Sets the predicting_config of this PredictingConfig.


        :param predicting_config: The predicting_config of this PredictingConfig.  # noqa: E501
        :type: BasePredictingConfig
        """

        self._predicting_config = predicting_config

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PredictingConfig):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PredictingConfig):
            return True

        return self.to_dict() != other.to_dict()
