# coding: utf-8
# Copyright 2023 OpenSPG Authors
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.


"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.common.rest.configuration import Configuration


class SearchEngineIndexResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"conn_info": "str", "index_name": "str"}

    attribute_map = {"conn_info": "connInfo", "index_name": "indexName"}

    def __init__(
        self, conn_info=None, index_name=None, local_vars_configuration=None
    ):  # noqa: E501
        """SearchEngineIndexResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._conn_info = None
        self._index_name = None
        self.discriminator = None

        if conn_info is not None:
            self.conn_info = conn_info
        if index_name is not None:
            self.index_name = index_name

    @property
    def conn_info(self):
        """Gets the conn_info of this SearchEngineIndexResponse.  # noqa: E501


        :return: The conn_info of this SearchEngineIndexResponse.  # noqa: E501
        :rtype: str
        """
        return self._conn_info

    @conn_info.setter
    def conn_info(self, conn_info):
        """Sets the conn_info of this SearchEngineIndexResponse.


        :param conn_info: The conn_info of this SearchEngineIndexResponse.  # noqa: E501
        :type: str
        """

        self._conn_info = conn_info

    @property
    def index_name(self):
        """Gets the index_name of this SearchEngineIndexResponse.  # noqa: E501


        :return: The index_name of this SearchEngineIndexResponse.  # noqa: E501
        :rtype: str
        """
        return self._index_name

    @index_name.setter
    def index_name(self, index_name):
        """Sets the index_name of this SearchEngineIndexResponse.


        :param index_name: The index_name of this SearchEngineIndexResponse.  # noqa: E501
        :type: str
        """

        self._index_name = index_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SearchEngineIndexResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SearchEngineIndexResponse):
            return True

        return self.to_dict() != other.to_dict()
